*note workbook must be closed for this to dunction
*set rownumber to one is not otherwise declared
$if not declared excelrownumber      scalar excelrownumber row number in Excel /1/;

*if first passed in parameter is empty just quit
$if "a%1" == "a" $exit

*this clears the whole workbook
$iftheni.cwb "%1" == "clearworkbook"
    $$if "a%2" == "a" $exit
*   do this at execution time allowing for the possibility that some other workbook functions have gone on
    $$if exists %2 execute 'rm %2'; 
    $$if exists "%2.xlsx" execute 'rm %2.xlsx'; 
    $$exit
$endif.cwb



$if not set settoexcel $set settoexcel

*below is python code to figure out what is to be done
$onEmbeddedCode Python:
import os
import gams.transfer as gt
args = [
  '''%1''',  '''%2''',  '''%3''',  '''%4''',  '''%5''',  '''%6''',  '''%7''',  '''%8''',  '''%9''',  '''%10''',
  '''%11''', '''%12''', '''%13''', '''%14''', '''%15''', '''%16''', '''%17''', '''%18''', '''%19''', '''%20''',
  '''%21''', '''%22''', '''%23''', '''%24''', '''%25''', '''%26''', '''%27''', '''%28''', '''%29''', '''%30''',
]
args = list(filter(len, args))  # remove empty arguments

#processing of sheets to be cleared
if args[0].lower() == "clearsheet":
  excel_file = args[1]
  if not os.path.splitext(excel_file)[1]:
    excel_file += ".xlsx"
  inc_str = f"""
embeddedCode Python:
  import openpyxl
  wb = openpyxl.load_workbook('{excel_file}', read_only=False, data_only=False)
  sheets = {[x.lower() for x in args[2:]]}
  for idx, s in enumerate(wb.sheetnames):
    if s.lower() in sheets:
      del wb[s]
      wb.create_sheet(s, idx)
  wb.save('{excel_file}')
endEmbeddedCode"""
else:
#process command to put out information
  # parse arguments
  set_to_excel = '''%settoexcel%'''
  # pick up numberof things in row and_ column from first and_ second arguments
  rdim, cdim = map(int, args[:2])
  # pick up name of gams symbol to send to excel from third argument
  sym_to = sym_from = args[2]
  # figure number of sets_ that need to be specified
  dim_to = rdim + cdim

  # pick up sets to vary over
  has_dim_from = "(" in args[3]

  # figure how much to skip over to get to name of workbook
  offset = dim_to + 3 + has_dim_from - (not has_dim_from and dim_to == 1)

  # pick up name of workbook
  excel_file = args[offset]

  # pick up name of sheet to use
  sheet_name = args[offset + 1]

  if set_to_excel and gams.db[set_to_excel].dimension != 1:
      raise Exception(f"Set {set_to_excel} used with 'settoexcel' has to be 1-dimensional.")
  if not os.path.splitext(excel_file)[1]:
    excel_file += ".xlsx"
  # break out the sets specified in the fourth argument
  if has_dim_from:
      dim_from = len(args[3].split(","))
      dom_from = [x.lower() for x in args[3].replace("(", "").replace(")", "").split(",")]
      dom_from_str = args[3].replace('"', '').replace("'", '')
      dom_to = [args[i + 4].lower() for i in range(dim_to)]
      dom_to_str = "(" + ",".join(dom_to) + ")"

  # write Connect instructions
  put_str = 'put_utility "ecArguments" / ' + f"'--excelrownumber=' (excelrownumber + {1 if set_to_excel else 0}):0:0 "
  yaml_str = f"""
#read information into connect from GAMS
- GAMSReader:
    symbols:
      - name: {sym_from}
      - name: excelrownumber"""
  if set_to_excel:
    put_str += "' --settoexcelrownumber=' (excelrownumber):0:0 "
    yaml_str += f"""
      - name: {set_to_excel}"""

  # identify sets under control and generate Filter agent if required
  if has_dim_from and dim_to < dim_from:
    controlled_sets = []
    fixed_labels = []
    for idx, d in enumerate(dom_from):
      if d.startswith(('"', "'")):
        d = d.strip(d[0])
        fixed_labels.append((idx + 1, d))
      elif d in dom_to:
        dom_to.remove(d)
      else:
        controlled_sets.append((idx + 1, d))

    if controlled_sets or fixed_labels:
      sym_to = args[2] + "_filter"
      yaml_str += f"""
#use filter to reduce problem only to the sets that are to be put into EXCEL
#this skip elements that are places in quotes in the passetd array dimension and any set controlled for example within GAMS Loop commands
- Filter:
    name: {sym_from}
    newName: {sym_to}
    labelFilters:"""

      sym_from = sym_to

      for s in controlled_sets:
        put_str += f"' --controlled_set_{s[0]}=\"' {s[1]}.tl:0 '\"'"
        yaml_str += f"""
      - column: {s[0]}
        keep: ['%&controlled_set_{s[0]}%&']"""

      for s in fixed_labels:
        yaml_str += f"""
      - column: {s[0]}
        regex: '(?i)\\b{s[1]}\\b'"""

  # we have domains and need Projection agent
  if has_dim_from:
    sym_to = args[2] + "_proj"
    yaml_str += f"""

#rearrange set_ order if needed as perscibed by commands
- Projection:
    name: {sym_from + dom_from_str}
    newName: {sym_to + dom_to_str}"""

  # ExcelWriter for exporting data to Excel
  yaml_str += f"""
#generate the write to excel
#note the A in the range commands below always writes in column A of the worksheet
- ExcelWriter:
    file: {excel_file}
    symbols:"""
  if set_to_excel:
    yaml_str += f"""
      - name: {set_to_excel}
        range: {sheet_name}!A%&settoexcelrownumber%&
        columnDimension: 1"""
  yaml_str += f"""
      - name: {sym_to}
        range: {sheet_name}!A%&excelrownumber%&
        columnDimension: {cdim}"""

  # adjust excelrownumber so it is below this entry
  offset = 3
  if set_to_excel:
    offset += 1
  yaml_str += f"""
- PythonCode:
    code: |
      offset = {offset}
      sym = connect.container['{sym_to}']
      if {rdim} == 0:
        nr_rows = 1 + {cdim}
      elif {cdim} == 0:
        nr_rows = sym.number_records
      else:
        dom = sym.domain
        nr_rows = sym.pivot(index=dom[:{rdim}], columns=dom[{rdim}:]).shape[0] + {cdim}
      gams.set('excelrownumber', [connect.container['excelrownumber'].toValue() + nr_rows + offset])"""

  inc_str = put_str + ";\n" + "$escape &\n" + "embeddedCode Connect:" + yaml_str + "\nendEmbeddedCode\n"
with open(r"%gams.scrDir%to_excel.%gams.scrExt%", "w") as f:
  f.write(inc_str)
$offEmbeddedCode

$include "%gams.scrDir%to_excel.%gams.scrExt%"
